Subject: bug#54613: 29.0.50; uncomment-region in sh-mode deletes extra char

From: Filipp Gunbin <[email-masked]>
Date: Tue, 29 Mar 2022 18:17:35 +0300

On 29/03/2022 14:59 +0200, Lars Ingebrigtsen wrote:

> Filipp Gunbin <[email-masked]> writes:
>
>> - Notice that `-' after "cat" disappeared
>
> I can reproduce this issue, too.
>
> What happens is that we have the following:
>
> curl -s -d @- http://example.org <<EOF \
> # cat -
>
> with point after "cat -".  In that case, (comment-enter-backward) will
> skip back past the " -", because comment-end-skip is
>
> "[ 	]*\\(\\s>\\|
> \\)"
>
> And...  \s> matches the " -\\'"?  Hm.  I'm not sure what's the real
> problem here is.  Should comment-end-skip have that value in shell
> scripts?  On the other hand, commenting out bits of a heredoc-introduced
> command with a continuation line is pretty hairy in itself.
>

I'm seeing in debugging that "-" after "cat" gets syntax-class "comment
end", which seems wrong.  Just in buffer, outside of running
uncomment-region, it doesn't happen.

Filipp